//
//  ViewController.m
//  MemoryManagement
//
//  Created by Christopher Ching on 13-04-03.
//  Copyright (c) 2013 CodeWithChris. All rights reserved.
//

#import "ViewController.h"
#import "MyClass.h"

@interface ViewController ()

@end

@implementation ViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    
    MyClass *myClassInstance = [[MyClass alloc] init];
    
    MyClass *secondReference = [myClassInstance retain];
    
    [myClassInstance release];
    
    // do something with secondReference
    // if i did not retain it when assigning it to secondReference,
    // calling the method below would crash the app
    [secondReference doSomething];
    
    // if i don't release it to bring the retain counter to 0,
    // it'll cause a memory leak
    [secondReference release];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
